library ieee;
library std;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use ieee.math_real.all;

package CABAC_EncParameters is

    constant ctxIdxRange : integer := 120;
    constant InputW : integer := 34;
    constant InputWLen : integer := integer(floor(log2(real(InputW))+real(1)));
    constant OutputW : integer := 40; 
    constant OutputWLen : integer := integer(floor(log2(real(OutputW))+real(1))); -- Number of bits required to represent OutputW.


    constant PutBitLoopLen : integer := 10; -- TODO: Potential overflow here if bitsOutstanding > PutBitLoopLen


end CABAC_EncParameters;