----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/07/2016 05:43:06 PM
-- Design Name: 
-- Module Name: Carrier_IP_TB - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
library std;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity CABAC_Testbench is

end CABAC_Testbench;

architecture Behavioral of CABAC_Testbench is

signal GCLK : STD_LOGIC;
signal LD   : STD_LOGIC_VECTOR (7 downto 0);
signal BTN  : STD_LOGIC_VECTOR (4 downto 0);
signal TestON : std_logic;
signal TestRESETN : std_logic;
signal TestWREN : std_logic;
signal WORKING : std_logic;
signal index_o : std_logic_vector(3 downto 0);
signal Testout1 : std_logic_vector(31 downto 0);
signal Testout2 : std_logic_vector(31 downto 0);
signal Coeffsout : std_logic_vector(111 downto 0);
signal Testin0 : std_logic_vector(31 downto 0);
signal Testin1 : std_logic_vector(31 downto 0);
signal Testin2 : std_logic_vector(31 downto 0);
signal Coeffsin : std_logic_vector(111 downto 0);


	component CABAC is
		port (
        GCLK : in std_logic;
        LD : out std_logic_vector(7 downto 0);
        BTN : in std_logic_vector(4 downto 0);
        TestON : in std_logic;
        TestRESETN : in std_logic;
        TestWREN : in std_logic;
        WORKING : inout std_logic;
        index_o : out std_logic_vector(3 downto 0);
        Testout1 : out std_logic_vector(31 downto 0);
        Testout2 : out std_logic_vector(31 downto 0);
        Coeffsout : out std_logic_vector(111 downto 0);
        Testin0 : in std_logic_vector(31 downto 0);
        Testin1 : in std_logic_vector(31 downto 0);
        Testin2 : in std_logic_vector(31 downto 0);
        Coeffsin : in std_logic_vector(111 downto 0)
		);
	end component CABAC;

begin
CABAC_inst : CABAC
	port map (
		GCLK => GCLK,
		BTN => BTN,
		LD => LD,		
		TestON => TestON,
		TestRESETN => TestRESETN,
		TestWREN => TestWREN,
		WORKING => WORKING,
		index_o => index_o,
        Testout1 => Testout1,
        Testout2 => Testout2,
        Coeffsout => Coeffsout,
        Testin0 => Testin0,
        Testin1 => Testin1,
        Testin2 => Testin2,
        Coeffsin => Coeffsin
	);
	
	  -- Generates a 100MHz Clk
    CLKGEN: process is
    begin
      GCLK <= '1';
      wait for 5 ns;
      GCLK <= '0';
      wait for 5 ns;
    end process;
    
    TransformBlockProc: process
	
	constant Test_Vector_1 : std_logic_vector(111 downto 0) := "0001111000111000011000001001000110100010110001000000010100010100000111000010000000100000110000001100000010000000";
	constant Test_Vector_2 : std_logic_vector(111 downto 0) := "0100000101000000001001000010101000000000000000010000000000001000000000000000000000000000000000000100000000000000";
	constant Test_Vector_3 : std_logic_vector(111 downto 0) := "1111111000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";
	
	
    begin
	
	
	
        TestON <= '1';
		TestWREN <= '0';
        TestRESETN <= '0';
        wait for 1 ns;-- sync to GCLK
        TestRESETN <= '1';
        TestWREN <= '1';
		wait for 1 ns;-- sync to GCLK
        TestRESETN <= '0';
        TestWREN <= '0';
		wait for 3 ns;-- sync to GCLK
        TestRESETN <= '1';
        TestWREN <= '1';
        Coeffsin  <= Test_Vector_1;
        wait for 20ns;
        TestWREN <= '0';
		TestRESETN <= '0';
		wait for 10ns;
		TestRESETN <= '1';
        TestWREN <= '1';
        Coeffsin  <= Test_Vector_2;
        wait for 20ns;
        TestWREN <= '0';
		TestRESETN <= '0';
		wait for 10ns;
		TestRESETN <= '1';
        TestWREN <= '1';
        Coeffsin  <= Test_Vector_3;
        wait for 20ns;
        TestWREN <= '0';
		TestRESETN <= '0';
		wait for 10ns;
        wait for 200ns;
        --for i in 4 downto 0 loop

        
       --end loop;
    end process;
    
    
--    	  -- Generates a 100MHz Clk
--  BTN2GEN: process is
--  begin
--    BTN(2) <= '0';
--    Testin0 <= "00000000000000000000000000000000";
--    TestON <= '0';
--    TestRESETN <= '0';
--    wait for 5 ns;
--    BTN(2) <= '1';
--    Testin0 <= "11111111111111111111111111111111";
--    TestON <= '1';
--    TestRESETN <= '1';
--    wait for 50 ns;
--    BTN(2) <= '0';
--    wait for 50 ns;
--    BTN(2) <= '1';
--    wait for 5 ns;
--    BTN(2) <= '0';
--    wait for 100 ns;
--  end process;
  
--      	  -- Generates a 100MHz Clk
--    BTN0and4GEN: process is
--    begin
--    BTN(0) <= '0';
--    BTN(4) <= '0';
--    wait for 10 ns;
--    BTN(0) <= '1';
--    BTN(4) <= '0';
--    wait for 10 ns;
--    BTN(0) <= '0';
--    BTN(4) <= '0';
--    wait for 10 ns;
--    BTN(0) <= '1';
--    BTN(4) <= '0';
--    wait for 10 ns;
--    BTN(0) <= '0';
--    BTN(4) <= '0';
--    wait for 10 ns;
--    BTN(0) <= '0';
--    BTN(4) <= '1';
--    wait for 10 ns;
--    end process;

end Behavioral;
